@use './theme';

$cv-primary-normal-shadow-opacity: 0.15;
$cv-primary-hover-shadow-opacity: 0.3;
$cv-primary-focus-shadow-opacity: 0.2;
$cv-primary-disabled-shadow-opacity: 0;

$cv-secondary-normal-shadow-opacity: 0.08;
$cv-secondary-hover-shadow-opacity: 0.3;
$cv-secondary-focus-shadow-opacity: 0.2;
$cv-secondary-disabled-shadow-opacity: 0;

@mixin set-button-styles(
  $backgroundNormal,
  $textColorNormal,
  $shadowOpacityNormal,
  $backgroundHover,
  $shadowOpacityHover,
  $backgroundFocus,
  $borderColorFocus,
  $shadowOpacityFocus,
  $backgroundDisabled,
  $textColorDisabled,
  $shadowOpacityDisabled,
  $colorHover: $textColorNormal
) {
  @include theme.box-shadow(theme.$shadow);

  background-color: $backgroundNormal;
  color: $textColorNormal;
  min-width: 80px;
  padding: 0 16px;
  height: 24px !important;
  font-family: theme.$font-family-primary;
  font-size: theme.$font-size-base;
  line-height: 22px;
  border: 1px solid transparent;
  border-radius: 2px;
  cursor: pointer;

  &:focus {
    @include theme.box-shadow(1px 2px 4px rgba(theme.$color-primary-700, $shadowOpacityFocus));

    background-color: $backgroundFocus;
    border-color: $borderColorFocus;
  }

  &:hover {
    @include theme.box-shadow(1px 2px 4px rgba(theme.$color-primary-700, $shadowOpacityHover));

    background-color: $backgroundHover;
    color: $colorHover;
  }

  &:active {
    @include theme.box-shadow(1px 2px 4px rgba(theme.$color-primary-700, $shadowOpacityFocus));

    background-color: $backgroundFocus;
    border-color: $borderColorFocus;
  }

  &[disabled],
  &.disabled {
    @include theme.background-text-color($backgroundDisabled, $textColorDisabled);
    @include theme.box-shadow(1px 2px 4px rgba(theme.$color-primary-700, $shadowOpacityDisabled));

    cursor: not-allowed;
  }

  &.cv-btn-spinner {
    padding: 0 16px;
  }
}

.cv-btn-group {
  display: inline-flex;
  margin-top: 32px;
}

.cv-btn-group-block {
  display: flex;
  justify-content: flex-end;
}

.cv-btn:not(:first-child) {
  margin-left: 12px;
}

// primary buttons
.cv-btn-primary,
.cv-btn-primary-sm {
  @include set-button-styles(
    theme.$color-primary-default,
    theme.$cv-white !important,
    $cv-primary-normal-shadow-opacity,
    theme.$color-primary-hover,
    $cv-primary-normal-shadow-opacity,
    theme.$color-basic-focus,
    theme.$border-basic-color-1,
    $cv-primary-focus-shadow-opacity,
    theme.$color-secondary-disabled,
    theme.$text-disabled-color,
    $cv-primary-disabled-shadow-opacity
  );
}

// secondary buttons
.cv-btn-secondary,
.cv-btn-secondary-sm {
  @include set-button-styles(
    theme.$color-secondary-default,
    theme.$cv-white !important,
    $cv-secondary-normal-shadow-opacity,
    theme.$color-secondary-hover,
    $cv-secondary-hover-shadow-opacity,
    theme.$color-secondary-focus,
    theme.$color-secondary-focus-border,
    $cv-secondary-focus-shadow-opacity,
    theme.$color-secondary-disabled,
    theme.$text-disabled-color,
    $cv-secondary-disabled-shadow-opacity
  );
}
